package a.cardiscover;


import android.support.test.espresso.ViewInteraction;
import android.support.test.rule.ActivityTestRule;
import android.support.test.runner.AndroidJUnit4;
import android.test.suitebuilder.annotation.LargeTest;

import org.junit.Rule;
import org.junit.Test;
import org.junit.runner.RunWith;

import static android.support.test.InstrumentationRegistry.getInstrumentation;
import static android.support.test.espresso.Espresso.onView;
import static android.support.test.espresso.Espresso.openActionBarOverflowOrOptionsMenu;
import static android.support.test.espresso.Espresso.pressBack;
import static android.support.test.espresso.action.ViewActions.click;
import static android.support.test.espresso.action.ViewActions.closeSoftKeyboard;
import static android.support.test.espresso.action.ViewActions.replaceText;
import static android.support.test.espresso.action.ViewActions.scrollTo;
import static android.support.test.espresso.matcher.ViewMatchers.isDisplayed;
import static android.support.test.espresso.matcher.ViewMatchers.withContentDescription;
import static android.support.test.espresso.matcher.ViewMatchers.withId;
import static android.support.test.espresso.matcher.ViewMatchers.withParent;
import static android.support.test.espresso.matcher.ViewMatchers.withText;
import static org.hamcrest.Matchers.allOf;

@LargeTest
@RunWith(AndroidJUnit4.class)
public class MainActivityTest {

    @Rule
    public ActivityTestRule<MainActivity> mActivityTestRule = new ActivityTestRule<>(MainActivity.class);

    @Test
    public void mainActivityTest() {
        openActionBarOverflowOrOptionsMenu(getInstrumentation().getTargetContext());

        ViewInteraction appCompatTextView = onView(
                allOf(withId(R.id.title), withText("VINCULACIÓN"), isDisplayed()));
        appCompatTextView.perform(click());

        ViewInteraction textView = onView(
                withText("NUEVO DISPOSITIVO"));
        textView.perform(scrollTo(), click());


        ViewInteraction appCompatEditText = onView(
                allOf(withId(R.id.edittext)));
        appCompatEditText.perform(replaceText("Prueba"), closeSoftKeyboard());

        ViewInteraction appCompatButton = onView(
                allOf(withId(android.R.id.button1), withText("OK"),
                        withParent(allOf(withId(R.id.buttonPanel),
                                withParent(withId(R.id.parentPanel)))),
                        isDisplayed()));
        appCompatButton.perform(click());

        pressBack();

        ViewInteraction appCompatButton2 = onView(
                allOf(withId(R.id.button1), withText("POSICIÓN"),
                        withParent(withId(R.id.relativeLayout1)),
                        isDisplayed()));
        appCompatButton2.perform(click());

        ViewInteraction imageView = onView(
                allOf(withContentDescription("My Location"), isDisplayed()));
        imageView.perform(click());

        ViewInteraction button = onView(
                allOf(withId(R.id.button), withText("  SALVAR POSICIÓN  "),
                        withParent(allOf(withId(R.id.relativeLayout2),
                                withParent(withId(android.R.id.content)))),
                        isDisplayed()));
        button.perform(click());

        pressBack();

        ViewInteraction appCompatButton3 = onView(
                allOf(withId(R.id.button1), withText("POSICIÓN"),
                        withParent(withId(R.id.relativeLayout1)),
                        isDisplayed()));
        appCompatButton3.perform(click());

        pressBack();

        ViewInteraction appCompatButton4 = onView(
                allOf(withId(R.id.button2), withText("ENCONTRAR"),
                        withParent(withId(R.id.relativeLayout1)),
                        isDisplayed()));
        appCompatButton4.perform(click());

        pressBack();

    }

}
