package a.cardiscover;

import android.content.Context;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuItem;
import android.content.Intent;
import android.view.View;
import android.widget.Button;

public class MainActivity extends AppCompatActivity implements View.OnClickListener {

    protected Context context;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        // Se realiza la carga inicial de los datos almacenados
        cargaInicial();
   }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        //Acceso a la barra de menú
        int id = item.getItemId();
        if (id == R.id.action1) {
            // Acceso al menu Vinculacion
            Intent intent =
                    new Intent(MainActivity.this, Vinculacion.class);
            startActivity(intent);
        }
        if (id == R.id.action2) {
            // Acceso al menu Historial
            Intent intent =
                    new Intent(MainActivity.this, historial.class);
            startActivity(intent);
        }
        return super.onOptionsItemSelected(item);
    }

    public void onClick(View v) {

        // Acceso a los botones de la ventana principal
        String Pulsado=((Button) v).getText().toString();
        if (Pulsado.compareTo("POSICIÓN") == 0) {
            // Acceso a Posicion, lanzamos Activity situarPosicion
            Intent intent =
                    new Intent(MainActivity.this, situarPosicion.class);
            startActivity(intent);
        }
        else if (Pulsado.compareTo("ENCONTRAR") == 0) {
            // Acceso a Entontrar, lanzamos Activity encontrarVehiculo
            Intent intent =
                    new Intent(MainActivity.this, encontrarVehiculo.class);
            startActivity(intent);
        }
    }

    public void cargaInicial () {
//  Carga inicial de Datos. Para ello se llama al controlador de Datos y se ejecuta la funcion CargaInicial.
        ControladorDatos CD = new ControladorDatos();
        context=getApplicationContext();
        CD.CargaInicial(context);
    }


}
