package a.cardiscover;

import android.support.v4.app.FragmentActivity;
import android.os.Bundle;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.OnMapReadyCallback;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.MarkerOptions;

public class MapsHistorial extends FragmentActivity implements OnMapReadyCallback {

    // Se define el mapa
    private GoogleMap mMap3;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_maps_historial);
        SupportMapFragment mapFragment = (SupportMapFragment) getSupportFragmentManager()
                .findFragmentById(R.id.map3);
        mapFragment.getMapAsync(this);
    }

    @Override
    public void onMapReady(GoogleMap googleMap) {
        mMap3 = googleMap;
        // Se obtiene la posición a visualizar del historico del vehiculo seleccionado
        LatLng Ubicacion=historial.obtenerUbicacion();
        // Se crea el marcado con la posición y el título Vehiculo
        MarkerOptions posicionVh = new MarkerOptions()
                .position(Ubicacion)
                .title("Vehiculo");
        // Se define como imagen la de un vehiculo
        posicionVh.icon(BitmapDescriptorFactory.fromResource(R.drawable.car));
        mMap3.addMarker(posicionVh);
        // Centrado de mapa en el marcado y zoom para mejorar la visualización
        mMap3.moveCamera(CameraUpdateFactory.newLatLng(Ubicacion));
        mMap3.animateCamera(CameraUpdateFactory.zoomTo(16));
    }
}
