package a.cardiscover;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.Context;
import android.content.DialogInterface;
import android.graphics.Color;
import android.os.Bundle;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.EditText;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;
import android.view.Gravity;
import android.widget.Toast;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Set;

public class Vinculacion extends AppCompatActivity implements View.OnClickListener {

    // ultimo nos permite identificar el ultimo dispositivo seleccionado para su coloreado y posterior borrado de color
    static TableRow ultimo;
    private BluetoothAdapter BA;
    ArrayList listado;
    HashMap<String, String> myMap = new HashMap<String, String>();
    static String VehiculoSalvado;
    static String dispositivo;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_vinculacion);
        // Inicializamos el ArrayList que contendrá los dispositivos emparejados por Bluetooth.
        listado = new ArrayList();
        // Llamada a la funcion para obtención de dispositivos bluetooth emparejados. El resultado quedará en la variable listado.
        doDiscovery();
        TableLayout table = (TableLayout) findViewById(R.id.tableLayout1);
        table.setClickable(false);
        // Si existen datos en listado, se representan en Tabla.

        TableRow row = new TableRow(this);
        row.setGravity(Gravity.CENTER);
        row.setClickable(true);
        row.setOnClickListener(this);
        TextView tv = new TextView(this);
        tv.setOnClickListener(this);
        tv.setTextSize(35);
        tv.setGravity(Gravity.CENTER);
        tv.setText("NUEVO DISPOSITIVO");
        tv.setTextColor(Color.BLACK);
        tv.setClickable(true);
        row.addView(tv);
        table.addView(row);
        myMap.put("NUEVO DISPOSITIVO","00:00:00:00:00:00");

        if (listado != null) {
            for (int i = 0; i < listado.size(); i++) {
                TableRow row2 = new TableRow(this);
                row2.setGravity(Gravity.CENTER);
                row2.setClickable(true);
                row2.setOnClickListener(this);
                TextView tv2 = new TextView(this);
                tv2.setOnClickListener(this);
                tv2.setTextSize(35);
                tv2.setGravity(Gravity.CENTER);
                tv2.setText(listado.get(i).toString());
                tv2.setTextColor(Color.BLACK);
                tv2.setClickable(true);
                row2.addView(tv2);
                table.addView(row2);
            }
        }
    }

    @Override
    public void onClick(View v) {
        // En caso de selección de un dispostivo este se marca como dispositivo vinculado
        // En caso de existir un dispositivo seleccionado anterior se elimina el coloreado.
        if (ultimo != null)
            ultimo.setBackgroundColor(Color.WHITE);
        TableRow row;
        String dispositivoGuardado="";
        // si selecciona la TableRow independiente si se pulsa sobre el TextView o la TableRow.
        if (v instanceof TextView)
            row = (TableRow) v.getParent();
        else {
            row = (TableRow) v;
            v = ((TableRow) v).getChildAt(0);
        }
        // Se define la fila como ultima seleccionada
        ultimo = row;
        // Coloreado de la fila
        row.setBackgroundColor(Color.BLUE);
        dispositivo = ((TextView) v).getText().toString();
        showDiag();
    }

   /**
     * Descubrimiento dispositivos Bluetooth asociados
     */
    private void doDiscovery() {

        Context context = getApplicationContext();
        CharSequence text = "";
        int duration = Toast.LENGTH_SHORT;
        Toast toast = Toast.makeText(context, text, duration);
        // Revisión si existe adaptador bluetooth
        BA = BluetoothAdapter.getDefaultAdapter();
        if (BA != null) {
            // Si existe bluetooth se revisa si está activo
            if (BA.isEnabled()) {
              Set<BluetoothDevice> pairedDevices = BA.getBondedDevices();
              // Se revisa existencia de Dispositivos asociados
                if (pairedDevices != null) {
                    if (pairedDevices.size() > 0) {
                        // Loop respecto los dispositivos asociados
                        for (BluetoothDevice device : pairedDevices) {
                            // Se añade al Array el nombre del dispositivo para mostrar posteriormente
                            listado.add(device.getName());
                            myMap.put(device.getName(),device.getAddress());
                        }
                    } else {
                        // Notificación al usuario sobre no existencia de dispositivos emparejados
                        toast.setText("SIN DISPOSITIVOS EMPAREJADOS");
                        toast.show();
                    }
                }
            }
            else {
                // Notificación al usuario sobre Bluetooth inactivo
                toast.setText("BLUETOOTH INACTIVO");
                toast.show();
            }
        }
        else {
            // Notificación al usuario sobre Bluetooth inactivo
            toast.setText("DISPOSITIVO SIN BLUETOOTH");
            toast.show();
        }
    }

    protected void showDiag () {

        LayoutInflater layoutInflater = LayoutInflater.from(Vinculacion.this);
        View promptView = layoutInflater.inflate(R.layout.input_dialog, null);
        final EditText editText = (EditText) promptView.findViewById(R.id.edittext);
        new AlertDialog.Builder(this)
                .setView(promptView)
                .setCancelable(false)
                .setPositiveButton("OK", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        VehiculoSalvado=editText.getText().toString();
                        // Obtención del nombre seleccionado
                        String Address = myMap.get (dispositivo);
                        // Obtención del contexto a nivel de Activity
                        Context ctx = getApplicationContext();
                        // Se crea el String para notificación del usuario y se notifica
                        CharSequence text = "DISPOSITIVO  " + VehiculoSalvado + "  VINCULADO";
                        int duration = Toast.LENGTH_SHORT;
                        Toast toast = Toast.makeText(ctx, text, duration);
                        toast.show();
                        // Se llama al controlador de datos con el dispositivo vinculado para su almacenamiento.
                        ControladorDatos.dispositivoSeleccionado(VehiculoSalvado, Address, ctx);
                    }
                })
                .setNegativeButton("Cancel",
                        new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int id) {
                                dialog.cancel();
                            }
                        })
                .show();
    }
}



