package a.cardiscover;

import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;
import android.view.Gravity;
import com.google.android.gms.maps.model.LatLng;

public class historial extends AppCompatActivity implements View.OnClickListener {

    // Objeto ubicación que será llamado por el mapa de visualización
    static LatLng Ubicacion;
    // Se define la ultima tabla seleccionada para poder eliminar el coloreado por selección
    static TableRow ultimo;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_historial);
        // Llamada al controlador de datos para obtener el historial
        ControladorDatos CD = new ControladorDatos();
        String[] listado=CD.CargarHistorico(getApplicationContext());
        TableLayout table = (TableLayout) findViewById(R.id.tableLayout2);
        if (listado != null) {
            for (int i = 0; i < listado.length; i++) {
                TableRow row2 = new TableRow(this);
                row2.setGravity(Gravity.CENTER);
                row2.setClickable(true);
                row2.setOnClickListener(this);
                // Se particiona el string recibido a nivel de controlador de datos para cada valor del Array para obtener
                // los diferentes valores de vehiculo, posicion y fecha.
                String[] cadena = listado[i].split(";");
                TextView tv2_1 = new TextView(this);
                TextView tv2_2 = new TextView(this);
                TextView tv2_3 = new TextView(this);
                TextView tv2_4 = new TextView(this);
                tv2_1.setOnClickListener(this);
                tv2_1.setTextSize(17);
                tv2_1.setGravity(Gravity.CENTER_HORIZONTAL);
                tv2_1.setText(cadena[0]);
                tv2_1.setTextColor(Color.BLACK);
                tv2_1.setClickable(true);
                row2.addView(tv2_1);
                tv2_2.setOnClickListener(this);
                tv2_2.setTextSize(15);
                tv2_2.setGravity(Gravity.CENTER);
                tv2_2.setText(cadena[1]);
                tv2_2.setTextColor(Color.BLACK);
                tv2_2.setClickable(true);
                row2.addView(tv2_2);
                tv2_3.setOnClickListener(this);
                tv2_3.setTextSize(15);
                tv2_3.setGravity(Gravity.CENTER);
                tv2_3.setText(cadena[2]);
                tv2_3.setTextColor(Color.BLACK);
                tv2_3.setClickable(true);
                row2.addView(tv2_3);
                tv2_4.setOnClickListener(this);
                tv2_4.setTextSize(15);
                tv2_4.setGravity(Gravity.CENTER);
                tv2_4.setText(cadena[3]);
                tv2_4.setTextColor(Color.BLACK);
                tv2_4.setClickable(true);
                row2.addView(tv2_4);
                row2.setClickable(false);
                table.addView(row2);
            }
        }
    }

    @Override
    public void onClick (View v) {
        // En caso de acceso a alguna de las filas de la tabla de historal se mostrará el mapa de la ubicación

        // Se elimina el color de selección de la última fila seleccionada en caso que exista
        if (ultimo != null)
            ultimo.setBackgroundColor(Color.WHITE);
        // Se obtiene la fila seleccionada
        TableRow row=(TableRow) v.getParent();
        row.setClickable(false);
        // Se define la fila como la última seleccionada
        ultimo=row;
        // Se colorea la fila seleccionada
        row.setBackgroundColor(Color.BLUE);
        // Se obtienen los valores de Latitud y Longitud para la fila seleccionada
        String Latitud = ((TextView)row.getChildAt(1)).getText().toString();
        String Longitud = ((TextView)row.getChildAt(2)).getText().toString();
        // Se crea el objeto LatLng
        Ubicacion = new LatLng(Double.valueOf(Latitud.replace(",",".")),Double.valueOf(Longitud.replace(",",".")));
        // Si existe ubicación se llama a la clase MapsHistorial para mostrar la ubicación en mapa.
        if (!Latitud.equals("") && !Longitud.equals("")) {
            Intent intent =
                    new Intent(historial.this, MapsHistorial.class);
            startActivity(intent);
        }
    }
// Función usada por MapsHistorial para obtener la ubicación seleccionada.
    public static LatLng obtenerUbicacion () {
        return Ubicacion;
    }
}




