package a.cardiscover;

import android.bluetooth.BluetoothSocket;
import android.content.Context;
import android.content.DialogInterface;
import android.content.pm.PackageManager;
import android.location.Location;
import android.net.Uri;
import android.os.Build;
import android.os.Handler;
import android.os.ParcelUuid;
import android.support.v4.app.ActivityCompat;
import android.support.v4.app.FragmentActivity;
import android.os.Bundle;
import android.Manifest;
import com.google.android.gms.appindexing.Action;
import com.google.android.gms.appindexing.AppIndex;
import com.google.android.gms.appindexing.Thing;
import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.api.GoogleApiClient;
import com.google.android.gms.location.LocationListener;
import com.google.android.gms.location.LocationRequest;
import com.google.android.gms.location.LocationServices;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.OnMapReadyCallback;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AlertDialog;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.Toast;
import com.google.android.gms.maps.GoogleMap.OnMarkerDragListener;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Set;
import java.util.UUID;

public class situarPosicion extends FragmentActivity implements OnMapReadyCallback, View.OnClickListener, GoogleApiClient.ConnectionCallbacks,
        GoogleApiClient.OnConnectionFailedListener, OnMarkerDragListener,
        LocationListener {

    private GoogleMap mMap;
    private GoogleApiClient client;
    final ThreadLocal<LocationRequest> mLocationRequest = new ThreadLocal<>();
    GoogleApiClient mGoogleApiClient;
    protected Context context;
    private GoogleApiClient client2;
    Location mLastLocation;
    private Marker mCurrLocationMarker;
    Boolean conectado;
    private BluetoothAdapter BA;
    private Handler mHandler;
    private Boolean salida;
    private Boolean conexion_app;
    private static BluetoothSocket socket;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_situar_posicion);
        SupportMapFragment mapFragment = (SupportMapFragment) getSupportFragmentManager()
                .findFragmentById(R.id.map);
        mapFragment.getMapAsync(this);
        client2 = new GoogleApiClient.Builder(this).addApi(AppIndex.API).build();
        conectado=false;
        salida=false;
        conexion_app=false;

    }


  @Override
    public void onMapReady(GoogleMap googleMap) {
        mMap = googleMap;
      // Control de versión y solicitud de permisos en caso que sea necesario
        if (android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
            if (ContextCompat.checkSelfPermission(this,
                    Manifest.permission.ACCESS_FINE_LOCATION)
                    == PackageManager.PERMISSION_GRANTED) {
                buildGoogleApiClient();
                mMap.setMyLocationEnabled(true);
        } else {
                checkLocationPermission();
            }
        }
        else {
            buildGoogleApiClient();
            mMap.setMyLocationEnabled(true);
        }
    }

    public void onClick(View v) {

        // En caso de Click en la Activiy
        LatLng Posicion;
        String Pulsado = ((Button) v).getText().toString();
        try {
            // Se analiza acceso al botón de Salvar Posición
            if (Pulsado.compareTo("  SALVAR POSICIÓN  ") == 0) {
                // Obtención de la posición del marcador
                Posicion = mCurrLocationMarker.getPosition();
                // Llamada a la clase Vehiculo para definir nueva posición
                Vehiculo.Vehiculo_Actual.setPosicion(Vehiculo.Vehiculo_Actual.getNombre(), Vehiculo.Vehiculo_Actual.getAddress(), Posicion, getApplicationContext());
                // Notificación al usuario de posicion salvada.
                Context ctx = getApplicationContext();
                CharSequence text = "POSICION SALVADA";
                int duration = Toast.LENGTH_SHORT;
                Toast toast = Toast.makeText(ctx, text, duration);
                toast.show();
            }
        }
        catch (Exception e) {
            // Notificacón al usuari si no existe ubicación o bien dispositivo vinculado
            Context ctx = getApplicationContext();
            CharSequence text = "NO EXISTE DISPOSITIVO O UBICACIÓN";
            int duration = Toast.LENGTH_SHORT;
            Toast toast = Toast.makeText(ctx, text, duration);
            toast.show();
            }
    }

    //@Override
    public void onLocationChanged(Location location) {
        // Control del marcador según la posicion de la ubicación del usuario
        mLastLocation = location;
        if (mCurrLocationMarker != null) {
            mCurrLocationMarker.remove();
        }
        // Se obtiene la ubicación actual
        LatLng latLng = new LatLng(location.getLatitude(), location.getLongitude());
        // Se define un marcador con la posción actual
        MarkerOptions markerOptions = new MarkerOptions();
        markerOptions.position(latLng);
        markerOptions.title("Posicion Vehiculo");
        // Se permite la modificación de la posición del marcador.
        markerOptions.draggable(true);
        mCurrLocationMarker = mMap.addMarker(markerOptions);
        // Se centra la posición del marcador y se amplia para facilitar su visionado
        mMap.moveCamera(CameraUpdateFactory.newLatLng(latLng));
        mMap.animateCamera(CameraUpdateFactory.zoomTo(16));
               if (mGoogleApiClient != null) {
                 LocationServices.FusedLocationApi.removeLocationUpdates(mGoogleApiClient, this);
           }
        mMap.setOnMarkerDragListener(this);
    }

    public static final int MY_PERMISSIONS_REQUEST_LOCATION = 99;

    // Control y solicitud de permisos para acceso a la ubicación.
    private void checkLocationPermission() {
        if (ContextCompat.checkSelfPermission(this, Manifest.permission.ACCESS_FINE_LOCATION)
                != PackageManager.PERMISSION_GRANTED) {
            if (ActivityCompat.shouldShowRequestPermissionRationale(this,
                    Manifest.permission.ACCESS_FINE_LOCATION)) {
                new AlertDialog.Builder(this)
                        .setTitle("Se necesitan permisos de localizacion")
                        .setMessage("Se necesitan permisos de localización, acepte el uso de la funcion de localizacion")
                        .setPositiveButton("OK", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialogInterface, int i) {
                                ActivityCompat.requestPermissions(situarPosicion.this,
                                        new String[]{Manifest.permission.ACCESS_FINE_LOCATION},
                                        MY_PERMISSIONS_REQUEST_LOCATION);
                            }
                        })
                        .create()
                        .show();
            } else {
                ActivityCompat.requestPermissions(this,
                        new String[]{Manifest.permission.ACCESS_FINE_LOCATION},
                        MY_PERMISSIONS_REQUEST_LOCATION);
            }
        }
    }

    public void onConnected(Bundle bundle) {
        mLocationRequest.set(new LocationRequest());
        mLocationRequest.get().setInterval(1000);
        mLocationRequest.get().setFastestInterval(1000);
        mLocationRequest.get().setPriority(LocationRequest.PRIORITY_BALANCED_POWER_ACCURACY);
        if (ContextCompat.checkSelfPermission(this,
                Manifest.permission.ACCESS_FINE_LOCATION)
                == PackageManager.PERMISSION_GRANTED) {
            LocationServices.FusedLocationApi.requestLocationUpdates(mGoogleApiClient, mLocationRequest.get(), this);
        }
    }


    @Override
    public void onRequestPermissionsResult(int requestCode,
                                           String permissions[], int[] grantResults) {
        switch (requestCode) {
            case MY_PERMISSIONS_REQUEST_LOCATION: {
                if (grantResults.length > 0
                        && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                    if (ContextCompat.checkSelfPermission(this,
                            Manifest.permission.ACCESS_FINE_LOCATION)
                            == PackageManager.PERMISSION_GRANTED) {
                        if (mGoogleApiClient == null) {
                            buildGoogleApiClient();
                        }
                        mMap.setMyLocationEnabled(true);
                    }
                } else {
                    Toast.makeText(this, "permiso denegado", Toast.LENGTH_LONG).show();
                }
            }
        }
    }

    public Action getIndexApiAction() {
        Thing object = new Thing.Builder()
                .setName("situarPosicion Page")
                .setUrl(Uri.parse("http://[ENTER-YOUR-URL-HERE]"))
                .build();
        return new Action.Builder(Action.TYPE_VIEW)
                .setObject(object)
                .setActionStatus(Action.STATUS_TYPE_COMPLETED)
                .build();
    }

    @Override
    public void onStart() {
        super.onStart();
        client2.connect();
        AppIndex.AppIndexApi.start(client2, getIndexApiAction());
    }

    @Override
    public void onStop() {
        super.onStop();
        AppIndex.AppIndexApi.end(client2, getIndexApiAction());
        client2.disconnect();
    }

    protected synchronized void buildGoogleApiClient() {
        mGoogleApiClient = new GoogleApiClient.Builder(this)
                .addConnectionCallbacks(this)
                .addOnConnectionFailedListener(this)
                .addApi(LocationServices.API)
                .build();
        mGoogleApiClient.connect();
    }

    @Override
    public void onConnectionSuspended(int i) {}

    @Override
    public void onConnectionFailed(ConnectionResult connectionResult) {}


    @Override
    public void onMarkerDragStart(Marker marker) {
    }

    @Override
    public void onMarkerDrag(Marker marker) {
    }


    public void onMarkerDragEnd(Marker mCurrLocationMarker) {
        // En caso de mover el marcador, se actualiza el centrado del mapa respecto a su ubicación.
            mMap.animateCamera(CameraUpdateFactory.newLatLng(mCurrLocationMarker.getPosition()));
        }


    private void carCheckStatus () {

        if (Vehiculo.Vehiculo_Actual != null && salida) {
            String Vehiculo = a.cardiscover.Vehiculo.Vehiculo_Actual.getAddress();
            // Revisión si existe adaptador bluetooth
            BA = BluetoothAdapter.getDefaultAdapter();
            if (BA != null) {
                // Si existe bluetooth se revisa si está activo
                if (BA.isEnabled()) {
                    Set<BluetoothDevice> pairedDevices = BA.getBondedDevices();
                    // Se revisa existencia de Dispositivos asociados
                    if (pairedDevices != null) {
                        if (pairedDevices.size() > 0) {
                            // Loop respecto los dispositivos asociados
                            for (BluetoothDevice device : pairedDevices) {
                                // Se añade al Array el nombre del dispositivo para mostrar posteriormente
                                String Address=device.getAddress();
                                if (Address.compareTo(Vehiculo) == 0) {
                                    try {
                                       if (socket == null)
                                       {
                                           // si no existe socket probamos a crear una nueva conexion con Handsfree
                                         socket = device.createInsecureRfcommSocketToServiceRecord(UUID.fromString("0000111e-0000-1000-8000-00805f9b34fb"));
                                         socket.connect();
                                         conexion_app=true;
                                       }
                                       else if (!conectado) {
                                         // si existe socket pero no está conectado probamos a realzar nueva conexión
                                         socket = device.createInsecureRfcommSocketToServiceRecord(UUID.fromString("0000111e-0000-1000-8000-00805f9b34fb"));
                                            socket.connect();
                                            conexion_app=true;
                                        }
                                        OutputStream tmpOut = null;
                                        tmpOut = socket.getOutputStream();
                                        DataOutputStream mmOutStream = new DataOutputStream(tmpOut);
                                        byte[] buffer = new byte[8];
                                        mmOutStream.write(buffer);
                                        conectado=true;
                                    }
                                    catch (Exception e) {
                                        // si la conexion ha fallado y veniamos de una situacion de conexion guardamos la posicion
                                        if (conectado) {
                                            GuardarPosicion();
                                            conectado = false;
                                        }
                                    }
                               }
                            }
                        }
                    }
                }
            }
        }
        salida=true;
    }

    private void GuardarPosicion () {
        if (mCurrLocationMarker!=null) {
            // Obtención de la posición del marcador
            LatLng Posicion = mCurrLocationMarker.getPosition();
            // Llamada a la clase Vehiculo para definir nueva posición
            Vehiculo.Vehiculo_Actual.setPosicion(Vehiculo.Vehiculo_Actual.getNombre(), Vehiculo.Vehiculo_Actual.getAddress(), Posicion, getApplicationContext());
        }

    }

    protected void onPause () {
        super.onPause();
        // revisamos existencia de vehiculo actual y si tiene direccion bluetooth valida
        if (Vehiculo.Vehiculo_Actual != null && Vehiculo.Vehiculo_Actual.getAddress().compareTo("00:00:00:00:00:00") != 0) {
            // activamos busqueda automatica
            mHandler = new Handler();
            mStatusChecker.run();

        }
    }

    protected void onResume () {
        // Si se llama a onResume se para la busqueda automatica
        super.onResume();
        stopRepeatingTask();
    }

    protected void onRestart () {
        super.onResume();
    }

    protected void onDestroy () {
        // Si se llama a onDestroy se para la busqueda automatica
        super.onDestroy();
        stopRepeatingTask();
    }


    Runnable mStatusChecker = new Runnable() {
        @Override
        public void run() {
            // ejecucion en background para busqueda automatica
            int mInterval = 5000; // 3 segundos de intervalo para la repeticion de la tarea
            try {
                carCheckStatus();
            } finally {
                mHandler.postDelayed(mStatusChecker, mInterval);
            }
        }
    };

    void stopRepeatingTask() {
        // paramos la busqueda automatica y el handler
        if (mHandler != null) {
            mHandler.removeCallbacks(mStatusChecker);
        }
        try {
            // si tenemos conexiones activa cerramos el socket
            if (conexion_app)
                socket.close();
        } catch (Exception e) {
            salida=false;
        }
        salida=false;
    }





}
